package csun.cs320;

import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class Insert extends SimpleTagSupport {

  public Insert()
  {
    try
    {
      Class.forName("com.mysql.jdbc.Driver");
    }
    catch( ClassNotFoundException e )
    {
    }
  }

  private boolean isNumber( String s )
  {
    boolean result = true;
    try
    {
      double d = Double.parseDouble( s );
    }
    catch( NumberFormatException nfe )
    {
      result = false;
    }

    return result;
  }

  public String insert( String table, String attrs, String values )
	throws SQLException
  {
    String sql = "INSERT INTO " + table + " " + attrs + " VALUES " + values;

    String url = "jdbc:mysql:///csun?user=csun&password=abcd";
    Connection c = DriverManager.getConnection( url );
    c.createStatement().executeUpdate( sql );
    c.close();

    return sql;
  }

  public void doTag() throws IOException, JspException
  {
    PageContext pc = (PageContext) getJspContext();
    ServletRequest request = pc.getRequest();

    // Construct the insert statement. Two things here are pretty difficult:
    // a. How do we tell whether an attribute is string type, which requires
    //    single quotes around the attribute value, or the attribute is a
    //    numerical type.
    // b. How do we tell whether an attribute is the last one -- no
    //    comma after the last attribute.
    // for (a), the "right" solution is probably get the column type
    // using getMetaData, but here I use a simple hack by checking
    // whether the string can be converted to a Double.
    // for (b),  I just take the first parameter that is not "table"
    // or "add" and append it at the end.
    String attrs = "(";
    String values = "(";
    String lastAttr="", lastValue="";
    boolean isLast = true;

    Enumeration e = request.getParameterNames();
    while( e.hasMoreElements() )
    {
      String a = (String) e.nextElement();
      if( a.equals("table") || a.equals("add") ) continue;
      if( request.getParameter(a).trim().equals("") ) continue;

      if( isLast == true )
      {
        lastAttr = a;
        lastValue = request.getParameter(a);
        isLast = false;
        continue;
      }

      attrs += a + ", ";
      String v = request.getParameter(a);
      if( isNumber(v) )	values += v + ", ";
      else		values += "'" + v + "', ";
    }
    // now append the last one
    attrs += lastAttr + ")";
    if( isNumber(lastValue) )	values += lastValue + ") ";
    else			values += "'" + lastValue + "') ";

    try
    {
      insert(request.getParameter("table"), attrs, values);
    }
    catch( SQLException sqle )
    {
      // doTag cannot throw SQLException so we re-throw it as a JspException
      throw new JspException( sqle.getMessage() );
    }
  }

} // end of class Insert

